//
//	VidyoLocalCamera_Objc.h
//	VidyoClient
//
//	This file is auto generated, do not edit this file
//	Copyright (c) 2016 Vidyo, Inc. All rights reserved.
//

#import "VidyoCameraControlCapabilities_Objc.h"
#import "VidyoDevice_Objc.h"
#import "VidyoLocalRenderer_Objc.h"
#import "VidyoRemoteRenderer_Objc.h"
#import "VidyoVideoCapability_Objc.h"
typedef NS_ENUM(NSInteger, VCLocalCameraPosition){
	VCLocalCameraPositionUnknown,
	VCLocalCameraPositionFront,
	VCLocalCameraPositionBack
};
typedef NS_ENUM(NSInteger, VCLocalCameraTradeOffProfile){
	VCLocalCameraTradeOffProfileHigh,
	VCLocalCameraTradeOffProfileMedium,
	VCLocalCameraTradeOffProfileLow
};
@protocol VCLocalCameraIGetVideoCapabilitiesAsync

	-(void) onGetVideoCapabilitiesComplete:(NSMutableArray*)capabilities;
@end
@interface VCLocalCamera : NSObject
{
	void* objPtr;
	@public
	id<VCLocalCameraIGetVideoCapabilitiesAsync> localCameraIGetVideoCapabilitiesAsync;
}

	@property NSMutableString* id;
	@property NSMutableString* name;
	-(void) dealloc;
	-(long) addToLocalRenderer:(VCLocalRenderer*)localRenderer;
	-(BOOL) addToRemoteRenderer:(VCRemoteRenderer*)remoteRenderer;
	-(BOOL) allowRemoteCameraControl:(BOOL)allow;
	-(BOOL) controlPTZ:(int)pan Tilt:(int)tilt Zoom:(int)zoom;
	-(BOOL) controlPTZStart:(VCCameraControlDirection)cmd Timeout:(long)timeout;
	-(BOOL) controlPTZStop;
	-(BOOL) getBacklightCompensation;
	-(VCCameraControlCapabilities*) getControlCapabilities;
	-(VCLocalCameraTradeOffProfile) getFramerateTradeOffProfile;
	-(NSString*) getId;
	-(NSString*) getName;
	-(VCLocalCameraPosition) getPosition;
	-(NSString*) getPreviewLabel;
	-(VCLocalCameraTradeOffProfile) getResolutionTradeOffProfile;
	-(BOOL) getVideoCapabilities:(NSMutableArray*)capabilities;
	-(BOOL) getVideoCapabilitiesAsync:(id<VCLocalCameraIGetVideoCapabilitiesAsync>)localCameraIGetVideoCapabilitiesAsync;
	-(BOOL) isControlDigital;
	-(BOOL) isPaused;
	-(BOOL) isSuspended;
	-(BOOL) removeFromLocalRenderer:(VCLocalRenderer*)localRenderer;
	-(BOOL) removeFromRemoteRenderer:(VCRemoteRenderer*)remoteRenderer;
	-(void) resume;
	-(BOOL) setAspectRatioConstraint:(unsigned int)aspectRatioWidth AspectRatioHeight:(unsigned int)aspectRatioHeight;
	-(BOOL) setBacklightCompensation:(BOOL)backlightCompensation;
	-(BOOL) setBoundsConstraint:(unsigned int)minWidth MinHeight:(unsigned int)minHeight MaxWidth:(unsigned int)maxWidth MaxHeight:(unsigned int)maxHeight MaxFrameInterval:(long)maxFrameInterval MinFrameInterval:(long)minFrameInterval AspectRatioWidth:(unsigned int)aspectRatioWidth AspectRatioHeight:(unsigned int)aspectRatioHeight TemporalSpatialTradeOff:(unsigned int)temporalSpatialTradeOff;
	-(BOOL) setCapabilitiesConstraint:(NSMutableArray*)capabilities TemporalSpatialTradeOff:(unsigned int)temporalSpatialTradeOff;
	-(BOOL) setConstraints:(unsigned int)minWidth MinHeight:(unsigned int)minHeight MaxWidth:(unsigned int)maxWidth MaxHeight:(unsigned int)maxHeight MaxFrameInterval:(unsigned int)maxFrameInterval MinFrameInterval:(unsigned int)minFrameInterval AspectRatioWidth:(unsigned int)aspectRatioWidth AspectRatioHeight:(unsigned int)aspectRatioHeight TemporalSpatialTradeOff:(unsigned int)temporalSpatialTradeOff Capabilities:(NSMutableArray*)capabilities;
	-(BOOL) setControlCapabilities:(VCCameraControlCapabilities*)caps;
	-(void) setControlDigital:(BOOL)digital;
	-(BOOL) setFramerateTradeOffProfile:(VCLocalCameraTradeOffProfile)profile;
	-(BOOL) setMaxConstraint:(unsigned int)width Height:(unsigned int)height FrameInterval:(long)frameInterval;
	-(BOOL) setNudgeTimes:(long)panTime TiltTime:(long)tiltTime ZoomTime:(long)zoomTime;
	-(BOOL) setOrientation:(VCDeviceOrientation)orientation LockOrientation:(BOOL)lockOrientation;
	-(BOOL) setPositionInLocalRenderer:(VCLocalRenderer*)localRenderer X:(int)x Y:(int)y Width:(unsigned int)width Height:(unsigned int)height FrameInterval:(long)frameInterval;
	-(BOOL) setPreviewLabel:(NSString*)previewLabel;
	-(BOOL) setPreviewStreamLabel:(NSString*)previewLabel;
	-(BOOL) setResolutionTradeOffProfile:(VCLocalCameraTradeOffProfile)profile;
	-(void) setTargetBitRate:(unsigned int)bitRate;
	-(BOOL) showCameraControl:(BOOL)show;
	-(id) initWithObject:(void*)rPtr;
	-(void*)getObjectPtr;
@end
